# This file is encoded in UTF-8.  -*- coding: utf-8 -*-
Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary: 	GNU Emacs text editor
Name: 		emacs
Epoch: 		1
Version: 	23.1
Release: 	1
License: 	GPLv3+
URL: 		http://www.gnu.org/software/emacs/
Group: 		Editors
Source0: 	ftp://ftp.gnu.org/gnu/emacs/emacs-%{version}.tar.bz2
Source1: 	emacs.desktop
Source3: 	dotemacs.el
Source4: 	site-start.el
Source7: 	http://php-mode.svn.sourceforge.net/svnroot/php-mode/tags/php-mode-1.4.0/php-mode.el
Source8: 	php-mode-init.el
Source9: 	ssl.el
# rpm-spec-mode from Xemacs
Source10: 	http://cvs.xemacs.org/viewcvs.cgi/XEmacs/packages/xemacs-packages/prog-modes/rpm-spec-mode.el
Source11: 	rpm-spec-mode-init.el
Source13: 	focus-init.el
Source14: 	po-mode.el
Source15: 	po-mode-init.el
Source18: 	default.el
Source20: 	igrep.el
Source21: 	igrep-init.el

Patch0: glibc-open-macro.patch
Patch1: rpm-spec-mode.patch
Patch2: po-mode-auto-replace-date-71264.patch
Patch3: rpm-spec-mode-utc.patch
Patch4: emacs-gtk.patch
Patch5: emacs-23.1-xdg.patch
Patch6: emacs-23.1-cpp.patch
Patch7: emacs-23.1-scroll.patch
Patch8: emacs-23.1-indian.patch
Patch9: emacs-23.1-memmove.patch
Patch10: emacs-23.1-fontdpi.patch 
Patch11: emacs-23.1-hexl-mode.patch

Buildroot: 	%{_tmppath}/%{name}-%{version}-root
BuildArch:	i686
BuildRequires: 	libtiff-devel, libXau-devel, libXdmcp-devel, libXt-devel
BuildRequires: 	xorg-x11-proto-devel
BuildRequires: 	autoconf, automake, bzip2, cairo, texinfo
Requires: 	xorg-x11-fonts-ISO8859-1-100dpi
Requires: 	emacs-common = %{epoch}:%{version}-%{release}
Provides: 	emacs(bin)

# C and build patches

# Lisp and doc patches

%define paranoid 1
%define expurgate 0

%define site_lisp %{_datadir}/emacs/site-lisp
%define site_start_d %{site_lisp}/site-start.d 
%define bytecompargs -batch --no-init-file --no-site-file -f batch-byte-compile
%define pkgconfig %{_datadir}/pkgconfig

BuildRequires: desktop-file-utils


#Automatically resolved build dependencies
BuildRequires: alsa-lib-devel
BuildRequires: atk-devel
BuildRequires: cairo-devel
BuildRequires: dbus-devel
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: giflib-devel
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: gpm-devel
BuildRequires: gtk2+-devel
BuildRequires: libICE-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: librsvg-devel
BuildRequires: libSM-devel
BuildRequires: libtiff-devel
BuildRequires: libX11-devel
BuildRequires: libXft-devel
BuildRequires: libXpm-devel
BuildRequires: libXrender-devel
BuildRequires: ncurses-devel
BuildRequires: pango-devel
BuildRequires: perl
BuildRequires: pkg-config
BuildRequires: zlib-devel

%description
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package provides an emacs binary with support for X windows.

%package nox
Summary: 	GNU Emacs text editor without X support
Group: 		Editors
Requires: 	emacs-common = %{epoch}:%{version}-%{release}
Provides: 	emacs(bin)

%description nox
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package provides an emacs binary with no X windows support for running
on a terminal.

%package common
Summary: 	Emacs common files
Group: 		Editors
PreReq: 	/sbin/install-info, %{_sbindir}/alternatives

%description common
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package contains all the common files needed by emacs or emacs-nox.

%package el
Summary: 	Emacs Lisp source files included with Emacs.
Group:		Editors

%description el
Emacs-el contains the emacs-elisp sources for many of the elisp
programs included with the main Emacs text editor package.

You need to install emacs-el only if you intend to modify any of the
Emacs packages or see some elisp examples.

%define emacs_libexecdir %{_libexecdir}/emacs/%{version}/%{_host}

%prep
%setup -q
%patch0 -p1 -b .glibc-open-macro
%patch4 -p1 -b .gtk
%patch5 -p1 -b .xdg
%patch6 -p1
%patch7 -p1 -b .scroll
%patch8 -p1
%patch9 -p1 -b .memmove
%patch10 -p1 -b .fontdpi
%patch11 -p0
 	
# install rest of site-lisp files
( cd site-lisp
  cp %SOURCE7 %SOURCE9 %SOURCE10 %SOURCE14 .
# rpm-spec-mode can use compilation-mode
	patch < %PATCH1
 	# fix po-auto-replace-revision-date nil
	patch < %PATCH2
 	# rpm-spec-mode: added rpm-change-log-uses-utc variable
 	patch < %PATCH3
)
 	
# we prefer our emacs.desktop file
cp %SOURCE1 etc/emacs.desktop
 	
grep -v "tetris.elc" lisp/Makefile.in > lisp/Makefile.in.new \
&& mv lisp/Makefile.in.new lisp/Makefile.in
 	
# avoid trademark issues
%if %{paranoid}
rm -f lisp/play/tetris.el lisp/play/tetris.elc
%endif
	
%if %{expurgate}
rm -f etc/sex.6 etc/condom.1 etc/celibacy.1 etc/COOKIES etc/future-bug etc/JOKES
%endif
 	
%define info_files ada-mode auth autotype calc ccmode cl dbus dired-x ebrowse ediff efaq eintr elisp emacs emacs-mime epa erc eshell eudc flymake forms gnus idlwave info mairix-el message mh-e newsticker nxml-mode org pcl-cvs pgg rcirc reftex remember sasl sc ses sieve smtpmail speedbar tramp url vip viper widget woman
 	
if test "$(perl -e 'while (<>) { if (/^INFO_FILES/) { s/.*=//; while (s/\\$//) { s/\\//; $_ .= <>; }; s/\s+/ /g; s/^ //; s/ $//; print; exit; } }' Makefile.in)" != "%info_files"; then
echo Please update info_files >&2
exit 1
fi
%ifarch %{ix86}
	%define setarch setarch %{_arch} -R
%else
	%define setarch %{nil}
%endif 


%build
export CFLAGS="-DMAIL_USE_LOCKF $RPM_OPT_FLAGS"

#we patch configure.in so we have to do this 
autoconf 
%configure --with-dbus --with-gif --with-jpeg --with-png --with-rsvg --with-tiff --with-xft --with-xpm --with-x-toolkit=gtk

%__make bootstrap
%__make %{?_smp_mflags}

# remove versioned file so that we end up with .1 suffix and only one DOC file
rm src/emacs-%{version}.*

TOPDIR=${PWD}
${TOPDIR}/src/emacs %{bytecompargs} site-lisp/*.el 

%__make %{?_smp_mflags} -C lisp updates 

# Create pkgconfig file
cat > emacs.pc << EOF
sitepkglispdir=%{site_lisp}
sitestartdir=%{site_start_d}

Name: emacs
Description: GNU Emacs text editor 
Version: %{epoch}:%{version}
EOF

# Create macros.emacs RPM macro file 
cat > macros.emacs << EOF
%%_emacs_version %{version}
%%_emacs_ev %{?epoch:%{epoch}:}%{version} 
%%_emacs_evr %{?epoch:%{epoch}:}%{version}-%{release}
%%_emacs_sitelispdir %{site_lisp}
%%_emacs_sitestartdir %{site_start_d}
%%_emacs_bytecompile /usr/bin/emacs %bytecompargs
EOF

%install
rm -rf %{buildroot}

make install INSTALL="%{__install} -p" DESTDIR=%{buildroot} 

# let alternatives manage the symlink
rm %{buildroot}%{_bindir}/emacs

# rebuild without X support
# remove the versioned binary with X support so that we end up with .1 suffix for emacs-nox too
rm src/emacs-%{version}.*
%configure --without-x
%__make %{?_smp_mflags}

# install the emacs without X
install -m 0755 src/emacs-%{version}.1 %{buildroot}%{_bindir}/emacs-%{version}-nox

# make sure movemail isn't setgid
chmod 755 %{buildroot}%{emacs_libexecdir}/movemail

mkdir -p %{buildroot}%{site_lisp}
install -m 0644 %SOURCE4 %{buildroot}%{site_lisp}/site-start.el
install -m 0644 %SOURCE18 %{buildroot}%{site_lisp}

mv %{buildroot}%{_bindir}/{etags,etags.emacs}
mv %{buildroot}%{_mandir}/man1/{ctags.1,gctags.1}
mv %{buildroot}%{_mandir}/man1/{etags.1,etags.emacs.1}
mv %{buildroot}%{_bindir}/{ctags,gctags}

# install site-lisp files
install -m 0644 site-lisp/*.el{,c} %{buildroot}%{site_lisp}

mkdir -p %{buildroot}%{site_lisp}/site-start.d
install -p -m 0644 %SOURCE8 %SOURCE11 %SOURCE13 %SOURCE15 %{buildroot}%{site_lisp}/site-start.d 

# default initialization file
mkdir -p %{buildroot}%{_sysconfdir}/skel
install -m 0644 %SOURCE3 %{buildroot}%{_sysconfdir}/skel/.emacs

# install pkgconfig file
mkdir -p %{buildroot}/%{pkgconfig}
install -m 0644 emacs.pc %{buildroot}/%{pkgconfig}

# install rpm macro definition file 
mkdir -p %{buildroot}%{_sysconfdir}/rpm 
install -p -m 0644 macros.emacs %{buildroot}%{_sysconfdir}/rpm/ 

# after everything is installed, remove info dir
rm -f %{buildroot}%{_infodir}/dir
rm %{buildroot}%{_localstatedir}/games/emacs/*

# install desktop file 
mkdir -p %{buildroot}%{_datadir}/applications 
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %SOURCE1 

#
# create file lists
#
rm -f *-filelist {common,el}-*-files

( TOPDIR=${PWD}
  cd %{buildroot}

  find .%{_datadir}/emacs/%{version}/lisp \
    .%{_datadir}/emacs/%{version}/leim \
    .%{_datadir}/emacs/site-lisp \( -type f -name '*.elc' -fprint $TOPDIR/common-lisp-none-elc-files \) -o \( -type d -fprintf $TOPDIR/common-lisp-dir-files "%%%%dir %%p\n" \) -o \( -name '*.el.gz' -fprint $TOPDIR/el-bytecomped-files -o -fprint $TOPDIR/common-not-comped-files \)

)

# put the lists together after filtering  ./usr to /usr
sed -i -e "s|\.%{_prefix}|%{_prefix}|" *-files
cat common-*-files > common-filelist
cat el-*-files common-lisp-dir-files > el-filelist

%clean
rm -rf %{buildroot}

%define info_files ada-mode autotype calc ccmode cl dired-x ebrowse ediff efaq eintr elisp0 elisp1 elisp emacs emacs-mime emacs-xtra erc eshell eudc flymake forms gnus idlwave info message mh-e newsticker org pcl-cvs pgg rcirc reftex sc ses sieve smtpmail speedbar tramp url viper vip widget woman

%preun
alternatives --remove emacs %{_bindir}/emacs-%{version} || :

%posttrans
alternatives --install %{_bindir}/emacs emacs %{_bindir}/emacs-%{version} 80 || :

%preun nox
alternatives --remove emacs %{_bindir}/emacs-%{version}-nox || :

%posttrans nox
alternatives --install %{_bindir}/emacs emacs %{_bindir}/emacs-%{version}-nox 70 || :

%post common
for f in %{info_files}; do
  /sbin/install-info %{_infodir}/$f.gz %{_infodir}/dir 2> /dev/null || :
done

%preun common
alternatives --remove etags %{_bindir}/etags.emacs || :
if [ "$1" = 0 ]; then
  for f in %{info_files}; do
    /sbin/install-info --delete %{_infodir}/$f.gz %{_infodir}/dir 2> /dev/null || :
  done
fi

%posttrans common
alternatives --install %{_bindir}/etags emacs.etags %{_bindir}/etags.emacs 80 \
	--slave %{_mandir}/man1/etags.1.gz emacs.etags.man %{_mandir}/man1/etags.emacs.1.gz

%files
%defattr(-,root,root)
%{_bindir}/emacs-%{version}
%dir %{_libexecdir}/emacs
%dir %{_libexecdir}/emacs/%{version}
%dir %{emacs_libexecdir}
%{_datadir}/applications/emacs.desktop
%{_datadir}/icons/hicolor/*/apps/emacs.png

%files nox
%defattr(-,root,root)
%{_bindir}/emacs-%{version}-nox
%dir %{_libexecdir}/emacs
%dir %{_libexecdir}/emacs/%{version}
%dir %{emacs_libexecdir}

%files -f common-filelist common
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/skel/.emacs
%doc etc/NEWS BUGS README
%{_sysconfdir}/rpm/macros.emacs
%{_datadir}/icons/hicolor/16x16/apps/emacs22.png
%{_datadir}/icons/hicolor/24x24/apps/emacs22.png
%{_datadir}/icons/hicolor/32x32/apps/emacs22.png
%{_datadir}/icons/hicolor/48x48/apps/emacs22.png
%{_datadir}/icons/hicolor/scalable/apps/emacs.svg
%{_datadir}/icons/hicolor/scalable/mimetypes/emacs-document.svg
%{_bindir}/b2m                                                        
%{_bindir}/ebrowse                                                    
%{_bindir}/emacsclient                                                
%{_bindir}/etags.emacs                                                
%{_bindir}/gctags                                                     
%{_bindir}/grep-changelog                                             
%{_bindir}/rcs-checkin
%{_mandir}/man1/b2m.1.gz
%{_mandir}/man1/ebrowse.1.gz
%{_mandir}/man1/emacs.1.gz
%{_mandir}/man1/emacsclient.1.gz
%{_mandir}/man1/etags.emacs.1.gz
%{_mandir}/man1/gctags.1.gz
%{_mandir}/man1/grep-changelog.1.gz
%{_mandir}/man1/rcs-checkin.1.gz
%{_infodir}/ada-mode.gz                                         
%{_infodir}/auth.gz                                             
%{_infodir}/autotype.gz                                         
%{_infodir}/calc-1.gz                                           
%{_infodir}/calc-2.gz                                           
%{_infodir}/calc-3.gz                                           
%{_infodir}/calc-4.gz                                           
%{_infodir}/calc-5.gz                                           
%{_infodir}/calc-6.gz                                           
%{_infodir}/calc.gz                                             
%{_infodir}/ccmode-1.gz                                         
%{_infodir}/ccmode-2.gz                                         
%{_infodir}/ccmode.gz                                           
%{_infodir}/cl.gz                                               
%{_infodir}/dbus.gz                                             
%{_infodir}/dired-x.gz                                          
%{_infodir}/ebrowse.gz                                          
%{_infodir}/ediff.gz                                            
%{_infodir}/efaq.gz                                             
%{_infodir}/eintr-1.gz                                          
%{_infodir}/eintr-2.gz                                          
%{_infodir}/eintr-3.gz                                          
%{_infodir}/eintr.gz                                            
%{_infodir}/elisp-1.gz                                          
%{_infodir}/elisp-10.gz                                         
%{_infodir}/elisp-11.gz                                         
%{_infodir}/elisp-2.gz                                          
%{_infodir}/elisp-3.gz                                          
%{_infodir}/elisp-4.gz                                          
%{_infodir}/elisp-5.gz                                          
%{_infodir}/elisp-6.gz                                          
%{_infodir}/elisp-7.gz                                          
%{_infodir}/elisp-8.gz                                          
%{_infodir}/elisp-9.gz                                          
%{_infodir}/elisp.gz                                            
%{_infodir}/emacs-1.gz                                          
%{_infodir}/emacs-2.gz                                          
%{_infodir}/emacs-3.gz                                          
%{_infodir}/emacs-4.gz                                          
%{_infodir}/emacs-5.gz                                          
%{_infodir}/emacs-6.gz                                          
%{_infodir}/emacs-7.gz                                          
%{_infodir}/emacs-8.gz                                          
%{_infodir}/emacs-mime.gz                                       
%{_infodir}/emacs.gz                                            
%{_infodir}/epa.gz                                              
%{_infodir}/erc.gz                                              
%{_infodir}/eshell.gz                                           
%{_infodir}/eudc.gz
%{_infodir}/flymake.gz
%{_infodir}/forms.gz
%{_infodir}/gnus-1.gz
%{_infodir}/gnus-2.gz
%{_infodir}/gnus-3.gz
%{_infodir}/gnus-4.gz
%{_infodir}/gnus-5.gz
%{_infodir}/gnus.gz
%{_infodir}/idlwave.gz
%{_infodir}/info.gz
%{_infodir}/mairix-el.gz
%{_infodir}/message.gz
%{_infodir}/mh-e-1.gz
%{_infodir}/mh-e-2.gz
%{_infodir}/mh-e.gz
%{_infodir}/newsticker.gz
%{_infodir}/nxml-mode.gz
%{_infodir}/org-1.gz
%{_infodir}/org-2.gz
%{_infodir}/org.gz
%{_infodir}/pcl-cvs.gz
%{_infodir}/pgg.gz
%{_infodir}/rcirc.gz
%{_infodir}/reftex.gz
%{_infodir}/remember.gz
%{_infodir}/sasl.gz
%{_infodir}/sc.gz
%{_infodir}/ses.gz
%{_infodir}/sieve.gz
%{_infodir}/smtpmail.gz
%{_infodir}/speedbar.gz
%{_infodir}/tramp.gz
%{_infodir}/url.gz
%{_infodir}/vip.gz
%{_infodir}/viper.gz
%{_infodir}/widget.gz
%{_infodir}/woman.gz
%dir %{_datadir}/emacs
%dir %{_datadir}/emacs/%{version}
%{_datadir}/emacs/%{version}/etc
%{_datadir}/emacs/%{version}/site-lisp
%{_libexecdir}/emacs
%attr(0644,root,root) %config %{_datadir}/emacs/site-lisp/default.el
%attr(0644,root,root) %config %{_datadir}/emacs/site-lisp/site-start.el

%files -f el-filelist el
%defattr(-,root,root)
%{pkgconfig}/emacs.pc
%dir %{_datadir}/emacs
%dir %{_datadir}/emacs/%{version}

%changelog
* Sun Feb 07 2010 Karsten Brockmann <arcam@ccux-linux.de> 23.1-1
- Version update
* Wed May 14 2008 Christian Metzen <metzench@ccux-linux.de> 22.2-1
- Initial release
